from abc import ABC, abstractmethod
from .shared_dict import SharedDictDescriptor, SharedDictWrapper
from typing import Any, Optional, Iterable
from .foreach import multiprocess_foreach


class MultiFooInterface(ABC):
    def __init__(self, shared_dict_descriptor: Optional[SharedDictDescriptor] = None):
        self._shared_dict_descriptor = shared_dict_descriptor

    @staticmethod
    @abstractmethod
    def worker(item: Any, shared_dict: SharedDictWrapper) -> Any:
        pass
