from foreach.types import ContextManagerBuilder

from contextlib import contextmanager
from typing import Callable, ContextManager


@contextmanager
def optional_context(use: bool, context_manager_builder: ContextManagerBuilder):
    if use:
        with context_manager_builder() as manager:
            yield manager
    else:
        yield None


def main():
    @contextmanager
    def ready_steady_go():
        print('ready')
        yield 'steady'
        print('go')

    with optional_context(use=True, context_manager_builder=ready_steady_go) as context:
        print(context)

    with optional_context(use=False, context_manager_builder=ready_steady_go) as context:
        print(context)


if __name__ == '__main__':
    main()
